<template>
    <header>
        <nav class="navbar navbar-expand-md navbar-dark bg-dark">
            <div class="container-fluid">
                <router-link class="navbar-brand" to="/">
                    <img
                        src="../../../../assets/images/logo.png"
                        alt=""
                        class="d-inline-block align-text-top"
                    />
                    E-Pokemon</router-link
                >
                <button
                    class="navbar-toggler"
                    type="button"
                    data-bs-toggle="collapse"
                    data-bs-target="#navbarSupportedContent"
                    aria-controls="navbarSupportedContent"
                    aria-expanded="false"
                    aria-label="Toggle navigation"
                >
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div id="navbarSupportedContent" class="collapse navbar-collapse">
                    <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                        <li class="nav-item">
                            <router-link class="nav-link" to="/products">
                                Products
                            </router-link>
                        </li>
                        <li class="nav-item">
                            <router-link class="nav-link position-relative" to="/cart">
                                <em class="bi bi-handbag-fill" />
                                <span
                                    class="
                                        position-absolute
                                        top-1
                                        start-100
                                        translate-middle
                                        badge
                                        rounded-pill
                                        bg-danger
                                    "
                                >
                                    {{ totalProducts || 0 }}
                                    <span class="visually-hidden">unread messages</span>
                                </span>
                            </router-link>
                        </li>
                    </ul>
                </div>

                <div v-if="!loggedIn" class="nav-item dropdown">
                    <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                        <li class="nav-item">
                            <router-link class="nav-link" to="/login">
                                Sign in
                            </router-link>
                        </li>
                    </ul>
                </div>
                <div v-else class="nav-item dropdown">
                    <button
                        type="button"
                        class="btn btn-secondary dropdown-toggle"
                        data-bs-toggle="dropdown"
                        data-bs-display="static"
                        aria-expanded="false"
                    >
                        {{ user.email }}
                    </button>
                    <ul class="dropdown-menu dropdown-menu-lg-end">
                        <li>
                            <button type="button" class="dropdown-item" @click="logout">
                                <em class="bi bi-power" /> Logout
                            </button>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
</template>

<script>
import {computed} from 'vue';
import {useStore} from 'vuex';
export default {
    setup() {
        const {getters, dispatch} = useStore();
        const logout = () => {
            dispatch('user/logout');
        };
        return {
            logout,
            loggedIn: computed(() => getters['user/loggedIn']),
            user: computed(() => getters['user/getUser']),
            totalProducts: computed(() => getters['product/totalProducts']),
        };
    },
};
</script>

<style scoped>
.router-link-exact-active {
    color: #fff !important;
}
</style>
